// $Id: param.h 452 2005-12-06 08:54:44Z satoken $
#ifndef __INC_PARAM_H__
#define __INC_PARAM_H__

#include <iostream>
#include <string>
#include <map>

class Param
{
public:
  enum { NONE=0, BOOL, INT, REAL, STRING };
  struct Options {
    int type;
    const char* short_name;
    const char* long_name;
    const char* default_value;
    const char* description;
  };

private:
  const char* app_;
  const char* more_opt_;
  const char* banner_;
  const Options* opt_;
  std::map< const char*, std::string > param_;
  std::string cmd_line_;
  
public:
  Param(const Options* opt, const char* more_opts=NULL,
	const char* banner=NULL);
  bool parse(int& argc, const char**& argv, std::ostream& os = std::cout);
  bool find(const char* long_name) const { return get_bool(long_name); }
  bool get_bool(const char* long_name) const;
  int get_int(const char* long_name) const;
  double get_real(const char* long_name) const;
  std::string get_string(const char* long_name) const;
  //const char* get_string(const char* long_name) const;
  void set_bool(const char* long_name, bool val);
  void set_int(const char* long_name, int val);
  void set_real(const char* long_name, double val);
  //void set_string(const char* long_name, const std::string& val);
  void set_string(const char* long_name, const char* val);
  void usage(std::ostream& os = std::cout) const;

  const std::string& cmd_line() const
  {
    return cmd_line_;
  }
};

#endif // __INC_PARAM_H__

// Local Variables:
// mode: C++
// End:

