/*
 * $Id: progress.h 482 2006-04-12 09:00:23Z satoken $
 *
 * PHMMTS -- an implementation of Pair Hidden Markov Models on Tree Structures,
 *           which is based on "Pair Hidden Markov Models on Tree Structures",
 *           Yasubumi Sakakibara, ISMB 2003.
 *
 * Copyright (C) 2003-2006 Kengo Sato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __INC_PROGRESS_H__
#define __INC_PROGRESS_H__

#include <iostream>
#include <sys/time.h>

namespace PHMMTS {
  class ProgressBar
  {
    struct timeval start_tm_;
    int cur_;
    int from_;
    int to_;
    int columns_;
  
  public:
    ProgressBar(int columns);
    void start(int from, int to);
    void update(int step=1);
    void finish();
  };
};

#endif // __INC_PROGRESS_H__

// Local Variables:
// mode: C++
// End:
