#!/usr/bin/env ruby

require 'open3'

$iteration=ARGV.shift.to_i
$outfile=ARGV.shift
$phmmts_opt="-n -i -d -t -3"

rfam=Struct.new("Rfam", :tag, :brackets, :sequence)
# read from Rfam format
seqlist=[]
ARGF.each_line("//\n") do |l|
  seqs=Hash.new("")
  brackets=""
  l.each_line() do |ll|
    if ll=~/^#=GC SS_cons\s+([^\s]+)$/
      brackets+=$1
    elsif ll=~/^#=GF/
      #header+=ll
    elsif ll=~%r'(^#|^\s*$|^//)'
      #
    else
      tag,s=ll.chomp.split
      seqs[tag]+=s
    end
  end
  seqs.each_pair{|tag,seq|
    seqlist.push(rfam.new(tag,brackets,seq))
  }
end

fh=open($outfile, "w")

$iteration.times do
  skeletal=seqlist[rand(seqlist.size)]
  query=seqlist[rand(seqlist.size)]
  s=Open3.popen3("./phmmts #{$phmmts_opt}")
  s[0].puts skeletal.brackets
  s[0].puts skeletal.sequence
  s[0].puts query.sequence
  s[0].close
  while l=s[1].gets
    fh.print "#{skeletal.tag} #{query.tag} "
    len1=skeletal.sequence.gsub(/\./,"").length
    len2=query.sequence.gsub(/\./,"").length
    fh.print "#{len1} #{len2} "
    if l=~/Line: \d+ Length: \d+ Time: [\d.]+s Score: ([\-\d]+)/
      fh.print "#{$1}\n"
    else
      fh.print "none\n"
    end
  end
  s[1].close
  s[2].close
  fh.flush
end
fh.close
