/*
 * $Id: rna.cpp 482 2006-04-12 09:00:23Z satoken $
 *
 * PHMMTS -- an implementation of Pair Hidden Markov Models on Tree Structures,
 *           which is based on "Pair Hidden Markov Models on Tree Structures",
 *           Yasubumi Sakakibara, ISMB 2003.
 *
 * Copyright (C) 2003-2006 Kengo Sato
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <cctype>
#include "defines.h"
#include "rna.h"

using namespace PHMMTS;

rna_t
PHMMTS::char2rna(char rna)
{
  switch (tolower(rna)) {
  case RNASymbol<char>::A:
    return static_cast<rna_t>(RNASymbol<rna_t>::A);
    break;
  case RNASymbol<char>::C:
    return static_cast<rna_t>(RNASymbol<rna_t>::C);
    break;
  case RNASymbol<char>::G:
    return static_cast<rna_t>(RNASymbol<rna_t>::G);
    break;
  case RNASymbol<char>::U:
    return static_cast<rna_t>(RNASymbol<rna_t>::U);
    break;
  default:
  case RNASymbol<char>::GAP:
    return static_cast<rna_t>(RNASymbol<rna_t>::GAP);
    break;
  }
}

char
PHMMTS::rna2char(const rna_t& rna)
{
  switch (rna) {
  case RNASymbol<rna_t>::A:
    return RNASymbol<char>::A;
    break;
  case RNASymbol<rna_t>::C:
    return RNASymbol<char>::C;
    break;
  case RNASymbol<rna_t>::G:
    return RNASymbol<char>::G;
    break;
  case RNASymbol<rna_t>::U:
    return RNASymbol<char>::U;
    break;
  default:
  case RNASymbol<rna_t>::GAP:
    return RNASymbol<char>::GAP;
    break;
  }
}

#if 0
#include <algorithm>
#include <string>
#include <vector>
#include <iterator>
#include <iostream>

int
main()
{
  std::string x("ac-guagg");
  RNASequence y(x.size());
  std::transform(x.begin(), x.end(), y.begin(), char2rna);
  std::copy(y.begin(), y.end(),
	    std::ostream_iterator<rna_t>(std::cout, " "));
  std::cout << std::endl;
  return 0;
}
#endif
